import sys 
sys.path.append(".")
from forum.handler import BaseHandler
from forum.wtforms import UserForm
from forum.models import UserModel
from uuid import uuid4
from forum.utils.email_util import send_mail
from config import email
from random import choice


class AddUserHandler(BaseHandler.BaseHandler):
    async def post(self):
        rs_data={}
        form = UserForm(self.request.arguments)
        if form.validate():
            email = form.email.data
            try:
                existed_user= await self.obj.get(UserModel,email = email)
                if existed_user:
                    rs_data['msg']='用户名已存在'
                    rs_data['code']=500
            except Exception as e:
                #可以注册
                form.id.data=uuid4()
                await self.obj.create(UserModel,**form.data)
                rs_data['msg']='注册成功'
                rs_data['code']=200
        else:
            rs_data['code'] = 500
            rs_data['msg'] = '注册失败'
            for field in form.errors:
                rs_data[field] = form[field][0]
        return self.finish(rs_data)

class SendEmail(BaseHandler):
    def generate_code(self):
        base = '0123456789'
        code = []
        #随机在0-9拿四个数字
        for i in range(4):
            code.append(choice(base))
        return ''.join(code)#转为字符串

    async def post(self):
        user_mail = self.get_body_argument('email')
        await send_mail(email.get('uname'),email.get('password'),user_mail,'<尚学堂-论坛>用户注册',self.generate_code())